local AnomalousDayMin = SandboxVars.AnomalousStormDaysMin or 2;
local AnomalousDayMax = SandboxVars.AnomalousStormDaysMax or 3;
local AnomalousLength = SandboxVars.AnomalousStormLength or 1;
local dayLength = SandboxVars.DayLength or 3;


Events.OnInitGlobalModData.Add(function(bool)
	local storm = ModData.getOrCreate("AnomalousStorm")

	if not storm["Hour"] then
		local dayRand = ZombRand(AnomalousDayMin, AnomalousDayMax)
		local hourRand = ZombRand(1, (23 - AnomalousLength))
		if dayLength == 1 then
			hourRand = ZombRand(1, (16 - AnomalousLength))
		end
	
		local table = {
			Day = 0,
			DayRandom = dayRand,
			Today = false,
			Active = false,
			Hour = 0,
			HourRandom = hourRand,
		}

		ModData.add("AnomalousStorm", table)
	end
end)

Events.EveryDays.Add(function()
	local storm = ModData.getOrCreate("AnomalousStorm")
	storm["Day"] = storm["Day"] + 1;
	storm["Hour"] = 0;
	storm["Active"] = false;
	print("ANOMALOUS STORM SYSTEM - RIDE THE RAINBOW! CRACK THE SKY!")

	if storm["Day"] == storm["DayRandom"] then
		local newRand = ZombRand(AnomalousDayMin, AnomalousDayMax);
		storm["Today"] = true;
		storm["Day"] = 0;
		storm["DayRandom"] = newRand;
		local newHourRand = ZombRand(1, (23 - AnomalousLength));
		storm["HourRandom"] = newHourRand;
	else
		storm["Today"] = false;
	end

	ModData.add("AnomalousStorm", storm)
end)

Events.EveryHours.Add(function()
	local storm = ModData.get("AnomalousStorm")
	if not storm["Today"] == true then return end

	print("ANOMALOUS STORM SYSTEM - STORMBRINGER COMING...")
	storm["Hour"] = storm["Hour"] + 1;

	if storm["Hour"] == (storm["HourRandom"] - 1) then
		getClimateManager():stopWeatherAndThunder()
	elseif storm["Hour"] == storm["HourRandom"] then
		getClimateManager():stopWeatherAndThunder()
		getClimateManager():triggerCustomWeatherStage(WeatherPeriod.STAGE_STORM, AnomalousLength);

		print("ANOMALOUS STORM SYSTEM - TIME TO DIIIIEEEE!")
		storm["Active"] = true;
	elseif storm["Hour"] > (storm["HourRandom"] + AnomalousLength + 2) then
		storm["Active"] = false;
		getClimateManager():getClimateColor(0):setEnableAdmin(false);		
	end
	
	ModData.add("AnomalousStorm", storm)
end)

Events.EveryTenMinutes.Add(function()
	local storm = ModData.get("AnomalousStorm")
	if not storm["Today"] == true then return end
	
	if storm["Active"] == true and getClimateManager():getIsThunderStorming() then
		getClimateManager():getClimateColor(0):setEnableAdmin(true);
		getClimateManager():getClimateColor(0):setAdminValueExterior(0.85,  0, 0, 0.6);
		getClimateManager():getClimateColor(0):setAdminValueInterior(0.85,  0, 0, 0.45)
	elseif storm["Active"] == true and (getClimateManager():isRaining() or getClimateManager():isSnowing()) then
		getClimateManager():getClimateColor(0):setEnableAdmin(true);
		getClimateManager():getClimateColor(0):setAdminValueExterior(0.55, 0, 0, 0.6);
		getClimateManager():getClimateColor(0):setAdminValueInterior(0.55, 0, 0, 0.45)		
	else
		getClimateManager():getClimateColor(0):setEnableAdmin(false);
	end
end)